# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Labservices::Mgmt::V2018_10_15
  module Models
    #
    # Represents an image from the Azure Marketplace
    #
    class GalleryImage < Resource

      include MsRestAzure

      # @return [String] The author of the gallery image.
      attr_accessor :author

      # @return [DateTime] The creation date of the gallery image.
      attr_accessor :created_date

      # @return [String] The description of the gallery image.
      attr_accessor :description

      # @return [GalleryImageReference] The image reference of the gallery
      # image.
      attr_accessor :image_reference

      # @return [String] The icon of the gallery image.
      attr_accessor :icon

      # @return [Boolean] Indicates whether this gallery image is enabled.
      attr_accessor :is_enabled

      # @return [Boolean] Indicates whether this gallery has been overridden
      # for this lab account
      attr_accessor :is_override

      # @return [String] The third party plan that applies to this image
      attr_accessor :plan_id

      # @return [Boolean] Indicates if the plan has been authorized for
      # programmatic deployment.
      attr_accessor :is_plan_authorized

      # @return [String] The provisioning status of the resource.
      attr_accessor :provisioning_state

      # @return [String] The unique immutable identifier of a resource (Guid).
      attr_accessor :unique_identifier

      # @return [LatestOperationResult] The details of the latest operation.
      # ex: status, error
      attr_accessor :latest_operation_result


      #
      # Mapper for GalleryImage class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'GalleryImage',
          type: {
            name: 'Composite',
            class_name: 'GalleryImage',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              author: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.author',
                type: {
                  name: 'String'
                }
              },
              created_date: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.createdDate',
                type: {
                  name: 'DateTime'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.description',
                type: {
                  name: 'String'
                }
              },
              image_reference: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.imageReference',
                type: {
                  name: 'Composite',
                  class_name: 'GalleryImageReference'
                }
              },
              icon: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.icon',
                type: {
                  name: 'String'
                }
              },
              is_enabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.isEnabled',
                type: {
                  name: 'Boolean'
                }
              },
              is_override: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.isOverride',
                type: {
                  name: 'Boolean'
                }
              },
              plan_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.planId',
                type: {
                  name: 'String'
                }
              },
              is_plan_authorized: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.isPlanAuthorized',
                type: {
                  name: 'Boolean'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              unique_identifier: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.uniqueIdentifier',
                type: {
                  name: 'String'
                }
              },
              latest_operation_result: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.latestOperationResult',
                type: {
                  name: 'Composite',
                  class_name: 'LatestOperationResult'
                }
              }
            }
          }
        }
      end
    end
  end
end
