# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Labservices::Mgmt::V2018_10_15
  module Models
    #
    # Represents a lab.
    #
    class LabFragment < Resource

      include MsRestAzure

      # @return [Integer] Maximum number of users allowed in the lab.
      attr_accessor :max_users_in_lab

      # @return [Duration] Maximum duration a user can use an environment for
      # in the lab.
      attr_accessor :usage_quota

      # @return [LabUserAccessMode] Lab user access mode (open to all vs.
      # restricted to those listed on the lab). Possible values include:
      # 'Restricted', 'Open'
      attr_accessor :user_access_mode

      # @return [String] The provisioning status of the resource.
      attr_accessor :provisioning_state

      # @return [String] The unique immutable identifier of a resource (Guid).
      attr_accessor :unique_identifier


      #
      # Mapper for LabFragment class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'LabFragment',
          type: {
            name: 'Composite',
            class_name: 'LabFragment',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              max_users_in_lab: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.maxUsersInLab',
                type: {
                  name: 'Number'
                }
              },
              usage_quota: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.usageQuota',
                type: {
                  name: 'TimeSpan'
                }
              },
              user_access_mode: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.userAccessMode',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              unique_identifier: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.uniqueIdentifier',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
