# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Labservices::Mgmt::V2018_10_15
  module Models
    #
    # Represents resource specific settings
    #
    class ResourceSettings

      include MsRestAzure

      # @return [String] The unique id of the resource setting
      attr_accessor :id

      # @return [String] The resource id of the gallery image used for creating
      # the virtual machine
      attr_accessor :gallery_image_resource_id

      # @return [String] The name of the image used to created the environment
      # setting
      attr_accessor :image_name

      # @return [ManagedLabVmSize] The size of the virtual machine. Possible
      # values include: 'Basic', 'Standard', 'Performance'
      attr_accessor :size

      # @return [Integer] The translated compute cores of the virtual machine
      attr_accessor :cores

      # @return [ReferenceVm] Details specific to Reference Vm
      attr_accessor :reference_vm


      #
      # Mapper for ResourceSettings class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ResourceSettings',
          type: {
            name: 'Composite',
            class_name: 'ResourceSettings',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              gallery_image_resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'galleryImageResourceId',
                type: {
                  name: 'String'
                }
              },
              image_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'imageName',
                type: {
                  name: 'String'
                }
              },
              size: {
                client_side_validation: true,
                required: false,
                serialized_name: 'size',
                type: {
                  name: 'String'
                }
              },
              cores: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'cores',
                type: {
                  name: 'Number'
                }
              },
              reference_vm: {
                client_side_validation: true,
                required: true,
                serialized_name: 'referenceVm',
                type: {
                  name: 'Composite',
                  class_name: 'ReferenceVm'
                }
              }
            }
          }
        }
      end
    end
  end
end
